summaryrefslogtreecommitdiffstats
path: root/source3/script
diff options
context:
space:
mode:
Diffstat (limited to 'source3/script')
-rwxr-xr-xsource3/script/tests/test_rpcclient_samlogon.sh27
1 files changed, 27 insertions, 0 deletions
diff --git a/source3/script/tests/test_rpcclient_samlogon.sh b/source3/script/tests/test_rpcclient_samlogon.sh
new file mode 100755
index 0000000000..01af7f80a1
--- /dev/null
+++ b/source3/script/tests/test_rpcclient_samlogon.sh
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+if [ $# -lt 3 ]; then
+cat <<EOF
+Usage: test_rpcclient_samlogon.sh USERNAME PASSWORD binding <rpcclient commands>
+EOF
+exit 1;
+fi
+
+USERNAME="$1"
+PASSWORD="$2"
+shift 2
+ADDARGS="$*"
+
+rpcclient_samlogon()
+{
+ $VALGRIND $BINDIR/rpcclient -U% -c "samlogon $USERNAME $PASSWORD;samlogon $USERNAME $PASSWORD" $@
+}
+
+
+incdir=`dirname $0`/../../../testprogs/blackbox
+. $incdir/subunit.sh
+testit "rpcclient dsenumdomtrusts" $VALGRIND $BINDIR/rpcclient $ADDARGS -U% -c "dsenumdomtrusts" || failed=`expr $failed + 1`
+testit "rpcclient getdcsitecoverage" $VALGRIND $BINDIR/rpcclient $ADDARGS -U% -c "getdcsitecoverage" || failed=`expr $failed + 1`
+testit "rpcclient samlogon" rpcclient_samlogon $ADDARGS || failed=`expr $failed +1`
+
+testok $0 $failed
77'>77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 800 801 802 803 804 805 806 807 808 809 810 811 812 813 814 815 816 817 818 819 820 821 822 823 824 825 826 827 828 829 830
# Authors:
#   Jason Gerard DeRose <jderose@redhat.com>
#
# Copyright (C) 2008  Red Hat
# see file 'COPYING' for use and warranty information
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; version 2 only
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

"""
Plugin framework.

The classes in this module make heavy use of Python container emulation. If
you are unfamiliar with this Python feature, see
http://docs.python.org/ref/sequence-types.html
"""

import re
import inspect
import errors
from errors import check_type, check_isinstance
from config import Environment, Env
import constants
import util


class ReadOnly(object):
    """
    Base class for classes with read-only attributes.

    Be forewarned that Python does not offer true read-only user defined
    classes. In particular, do not rely upon the read-only-ness of this
    class for security purposes.

    The point of this class is not to make it impossible to set or delete
    attributes, but to make it impossible to accidentally do so. The plugins
    are not thread-safe: in the server, they are loaded once and the same
    instances will be used to process many requests. Therefore, it is
    imperative that they not set any instance attributes after they have
    been initialized. This base class enforces that policy.

    For example:

    >>> ro = ReadOnly() # Initially unlocked, can setattr, delattr
    >>> ro.name = 'John Doe'
    >>> ro.message = 'Hello, world!'
    >>> del ro.message
    >>> ro.__lock__() # Now locked, cannot setattr, delattr
    >>> ro.message = 'How are you?'
    Traceback (most recent call last):
      File "<stdin>", line 1, in <module>
      File ".../ipalib/plugable.py", line 93, in __setattr__
        (self.__class__.__name__, name)
    AttributeError: read-only: cannot set ReadOnly.message
    >>> del ro.name
    Traceback (most recent call last):
      File "<stdin>", line 1, in <module>
      File "/home/jderose/projects/freeipa2/ipalib/plugable.py", line 104, in __delattr__
        (self.__class__.__name__, name)
    AttributeError: read-only: cannot del ReadOnly.name
    """

    __locked = False

    def __lock__(self):
        """
        Put this instance into a read-only state.

        After the instance has been locked, attempting to set or delete an
        attribute will raise AttributeError.
        """
        assert self.__locked is False, '__lock__() can only be called once'
        self.__locked = True

    def __islocked__(self):
        """
        Return True if instance is locked, otherwise False.
        """
        return self.__locked

    def __setattr__(self, name, value):
        """
        If unlocked, set attribute named ``name`` to ``value``.

        If this instance is locked, AttributeError will be raised.
        """
        if self.__locked:
            raise AttributeError('read-only: cannot set %s.%s' %
                (self.__class__.__name__, name)
            )
        return object.__setattr__(self, name, value)

    def __delattr__(self, name):
        """
        If unlocked, delete attribute named ``name``.

        If this instance is locked, AttributeError will be raised.
        """
        if self.__locked:
            raise AttributeError('read-only: cannot del %s.%s' %
                (self.__class__.__name__, name)
            )
        return object.__delattr__(self, name)


def lock(readonly):
    """
    Lock a `ReadOnly` instance.

    This is mostly a convenience function to call `ReadOnly.__lock__()`. It
    also verifies that the locking worked using `ReadOnly.__islocked__()`

    :param readonly: An instance of the `ReadOnly` class.
    """
    if not isinstance(readonly, ReadOnly):
        raise ValueError('not a ReadOnly instance: %r' % readonly)
    readonly.__lock__()
    assert readonly.__islocked__(), 'Ouch! The locking failed?'
    return readonly


class SetProxy(ReadOnly):
    """
    A read-only container with set/sequence behaviour.

    This container acts as a proxy to an actual set-like object (a set,
    frozenset, or dict) that is passed to the constructor. To the extent
    possible in Python, this underlying set-like object cannot be modified
    through the SetProxy... which just means you wont do it accidentally.
    """
    def __init__(self, s):
        """
        :param s: The target set-like object (a set, frozenset, or dict)
        """
        allowed = (set, frozenset, dict)
        if type(s) not in allowed:
            raise TypeError('%r not in %r' % (type(s), allowed))
        self.__s = s
        lock(self)

    def __len__(self):
        """
        Return the number of items in this container.
        """
        return len(self.__s)

    def __iter__(self):
        """
        Iterate (in ascending order) through keys.
        """
        for key in sorted(self.__s):
            yield key

    def __contains__(self, key):
        """
        Return True if this container contains ``key``.

        :param key: The key to test for membership.
        """
        return key in self.__s


class DictProxy(SetProxy):
    """
    A read-only container with mapping behaviour.

    This container acts as a proxy to an actual mapping object (a dict) that
    is passed to the constructor. To the extent possible in Python, this
    underlying mapping object cannot be modified through the DictProxy...
    which just means you wont do it accidentally.

    Also see `SetProxy`.
    """
    def __init__(self, d):
        """
        :param d: The target mapping object (a dict)
        """
        if type(d) is not dict:
            raise TypeError('%r is not %r' % (type(d), dict))
        self.__d = d
        super(DictProxy, self).__init__(d)

    def __getitem__(self, key):
        """
        Return the value corresponding to ``key``.

        :param key: The key of the value you wish to retrieve.
        """
        return self.__d[key]

    def __call__(self):
        """
        Iterate (in ascending order by key) through values.
        """
        for key in self:
            yield self.__d[key]


class MagicDict(DictProxy):
    """
    A mapping container whose values can be accessed as attributes.

    For example:

    >>> magic = MagicDict({'the_key': 'the value'})
    >>> magic['the_key']
    'the value'
    >>> magic.the_key
    'the value'

    This container acts as a proxy to an actual mapping object (a dict) that
    is passed to the constructor. To the extent possible in Python, this
    underlying mapping object cannot be modified through the MagicDict...
    which just means you wont do it accidentally.

    Also see `DictProxy` and `SetProxy`.
    """

    def __getattr__(self, name):
        """
        Return the value corresponding to ``name``.

        :param name: The name of the attribute you wish to retrieve.
        """
        try:
            return self[name]
        except KeyError:
            raise AttributeError('no magic attribute %r' % name)


class Plugin(ReadOnly):
    """
    Base class for all plugins.
    """
    __public__ = frozenset()
    __proxy__ = True
    __api = None

    def __get_name(self):
        """
        Convenience property to return the class name.
        """
        return self.__class__.__name__
    name = property(__get_name)

    def __get_doc(self):
        """
        Convenience property to return the class docstring.
        """
        return self.__class__.__doc__
    doc = property(__get_doc)

    def __get_api(self):
        """
        Return `API` instance passed to `finalize()`.

        If `finalize()` has not yet been called, None is returned.
        """
        return self.__api
    api = property(__get_api)

    @classmethod
    def implements(cls, arg):
        """
        Return True if this class implements ``arg``.

        There are three different ways this method can be called:

        With a <type 'str'> argument, e.g.:

        >>> class base(Plugin):
        ...     __public__ = frozenset(['attr1', 'attr2'])
        ...
        >>> base.implements('attr1')
        True
        >>> base.implements('attr2')
        True
        >>> base.implements('attr3')
        False

        With a <type 'frozenset'> argument, e.g.:

        With any object that has a `__public__` attribute that is
        <type 'frozenset'>, e.g.:

        Unlike ProxyTarget.implemented_by(), this returns an abstract answer
        because only the __public__ frozenset is checked... a ProxyTarget
        need not itself have attributes for all names in __public__
        (subclasses might provide them).
        """
        assert type(cls.__public__) is frozenset
        if isinstance(arg, str):
            return arg in cls.__public__
        if type(getattr(arg, '__public__', None)) is frozenset:
            return cls.__public__.issuperset(arg.__public__)
        if type(arg) is frozenset:
            return cls.__public__.issuperset(arg)
        raise TypeError(
            "must be str, frozenset, or have frozenset '__public__' attribute"
        )

    @classmethod
    def implemented_by(cls, arg):
        """
        Return True if ``arg`` implements public interface of this class.

        This classmethod returns True if:

        1. ``arg`` is an instance of or subclass of this class, and

        2. ``arg`` (or ``arg.__class__`` if instance) has an attribute for
           each name in this class's ``__public__`` frozenset.

        Otherwise, returns False.

        Unlike `Plugin.implements`, this returns a concrete answer because
        the attributes of the subclass are checked.

        :param arg: An instance of or subclass of this class.
        """
        if inspect.isclass(arg):
            subclass = arg
        else:
            subclass = arg.__class__
        assert issubclass(subclass, cls), 'must be subclass of %r' % cls
        for name in cls.__public__:
            if not hasattr(subclass, name):
                return False
        return True

    def finalize(self):
        """
        """
        lock(self)

    def set_api(self, api):
        """
        Set reference to `API` instance.
        """
        assert self.__api is None, 'set_api() can only be called once'
        assert api is not None, 'set_api() argument cannot be None'
        self.__api = api

    def __repr__(self):
        """
        Return 'module_name.class_name()' representation.

        This representation could be used to instantiate this Plugin
        instance given the appropriate environment.
        """
        return '%s.%s()' % (
            self.__class__.__module__,
            self.__class__.__name__
        )


class PluginProxy(SetProxy):
    """
    Allow access to only certain attributes on a `Plugin`.

    Think of a proxy as an agreement that "I will have at most these
    attributes". This is different from (although similar to) an interface,
    which can be thought of as an agreement that "I will have at least these
    attributes".
    """

    __slots__ = (
        '__base',
        '__target',
        '__name_attr',
        '__public__',
        'name',
        'doc',
    )

    def __init__(self, base, target, name_attr='name'):
        """
        :param base: A subclass of `Plugin`.
        :param target: An instance ``base`` or a subclass of ``base``.
        :param name_attr: The name of the attribute on ``target`` from which
            to derive ``self.name``.
        """
        if not inspect.isclass(base):
            raise TypeError(
                '`base` must be a class, got %r' % base
            )
        if not isinstance(target, base):
            raise ValueError(
                '`target` must be an instance of `base`, got %r' % target
            )
        self.__base = base
        self.__target = target
        self.__name_attr = name_attr
        self.__public__ = base.__public__
        self.name = getattr(target, name_attr)
        self.doc = target.doc
        assert type(self.__public__) is frozenset
        super(PluginProxy, self).__init__(self.__public__)

    def implements(self, arg):
        """
        Return True if plugin being proxied implements ``arg``.

        This method simply calls the corresponding `Plugin.implements`
        classmethod.

        Unlike `Plugin.implements`, this is not a classmethod as a
        `PluginProxy` can only implement anything as an instance.
        """
        return self.__base.implements(arg)

    def __clone__(self, name_attr):
        """
        Return a `PluginProxy` instance similar to this one.

        The new `PluginProxy` returned will be identical to this one except
        the proxy name might be derived from a different attribute on the
        target `Plugin`.  The same base and target will be used.
        """
        return self.__class__(self.__base, self.__target, name_attr)

    def __getitem__(self, key):
        """
        Return attribute named ``key`` on target `Plugin`.

        If this proxy allows access to an attribute named ``key``, that
        attribute will be returned.  If access is not allowed,
        KeyError will be raised.
        """
        if key in self.__public__:
            return getattr(self.__target, key)
        raise KeyError('no public attribute %s.%s' % (self.name, key))

    def __getattr__(self, name):
        """
        Return attribute named ``name`` on target `Plugin`.

        If this proxy allows access to an attribute named ``name``, that
        attribute will be returned.  If access is not allowed,
        AttributeError will be raised.
        """
        if name in self.__public__:
            return getattr(self.__target, name)
        raise AttributeError('no public attribute %s.%s' % (self.name, name))

    def __call__(self, *args, **kw):
        """
        Call target `Plugin` and return its return value.

        If `__call__` is not an attribute this proxy allows access to,
        KeyError is raised.
        """
        return self['__call__'](*args, **kw)

    def __repr__(self):
        """
        Return a Python expression that could create this instance.
        """
        return '%s(%s, %r)' % (
            self.__class__.__name__,
            self.__base.__name__,
            self.__target,
        )


def check_name(name):
    """
    Verify that ``name`` is suitable for a `NameSpace` member name.

    Raises `errors.NameSpaceError` if ``name`` is not a valid Python
    identifier suitable for use as the name of `NameSpace` member.

    :param name: Identifier to test.
    """
    check_type(name, str, 'name')
    regex = r'^[a-z][_a-z0-9]*[a-z0-9]$'
    if re.match(regex, name) is None:
        raise errors.NameSpaceError(name, regex)
    return name


class NameSpace(ReadOnly):
    """
    A read-only namespace with handy container behaviours.

    Each member of a NameSpace instance must have a ``name`` attribute whose
    value:

        1. Is unique among the members
        2. Passes the `check_name()` function

    Beyond that, no restrictions are placed on the members: they can be
    classes or instances, and of any type.

    The members can be accessed as attributes on the NameSpace instance or
    through a dictionary interface. For example:

    >>> class obj(object):
    ...     name = 'my_obj'
    ...
    >>> namespace = NameSpace([obj])
    >>> obj is getattr(namespace, 'my_obj') # As attribute
    True
    >>> obj is namespace['my_obj'] # As dictionary item
    True

    Here is a more detailed example:

    >>> class Member(object):
    ...     def __init__(self, i):
    ...             self.i = i
    ...             self.name = 'member_%d' % i
    ...     def __repr__(self):
    ...             return 'Member(%d)' % self.i
    ...
    >>> namespace = NameSpace(Member(i) for i in xrange(3))
    >>> namespace.member_0 is namespace['member_0']
    True
    >>> len(namespace) # Returns the number of members in namespace
    3
    >>> list(namespace) # As iterable, iterates through the member names
    ['member_0', 'member_1', 'member_2']
    >>> list(namespace()) # Calling a NameSpace iterates through the members
    [Member(0), Member(1), Member(2)]
    >>> 'member_1' in namespace # Does namespace contain 'member_1'?
    True
    """

    def __init__(self, members, sort=True):
        """
        :param members: An iterable providing the members.
        :param sort: Whether to sort the members by member name.
        """
        self.__sort = check_type(sort, bool, 'sort')
        if self.__sort:
            self.__members = tuple(sorted(members, key=lambda m: m.name))
        else:
            self.__members = tuple(members)
        self.__names = tuple(m.name for m in self.__members)
        self.__map = dict()
        for member in self.__members:
            name = check_name(member.name)
            assert name not in self.__map, 'already has key %r' % name
            self.__map[name] = member
            assert not hasattr(self, name), 'already has attribute %r' % name
            setattr(self, name, member)
        lock(self)

    def __len__(self):
        """
        Return the number of members.
        """
        return len(self.__members)

    def __iter__(self):
        """
        Iterate through the member names.

        If this instance was created with ``sort=True``, the names will be in
        alphabetical order; otherwise the names will be in the same order as
        the members were passed to the constructor.

        This method is like an ordered version of dict.iterkeys().
        """
        for name in self.__names:
            yield name

    def __call__(self):
        """
        Iterate through the members.

        If this instance was created with ``sort=True``, the members will be
        in alphabetical order by name; otherwise the members will be in the
        same order as they were passed to the constructor.

        This method is like an ordered version of dict.itervalues().
        """
        for member in self.__members:
            yield member

    def __contains__(self, name):
        """
        Return True if namespace has a member named ``name``.
        """
        return name in self.__map

    def __getitem__(self, spec):
        """
        Return a member by name or index, or returns a slice of members.

        :param spec: The name or index of a member, or a slice object.
        """
        if type(spec) is str:
            return self.__map[spec]
        if type(spec) in (int, slice):
            return self.__members[spec]
        raise TypeError(
            'spec: must be %r, %r, or %r; got %r' % (str, int, slice, spec)
        )

    def __repr__(self):
        """
        Return a pseudo-valid expression that could create this instance.
        """
        return '%s(<%d members>, sort=%r)' % (
            self.__class__.__name__,
            len(self),
            self.__sort,
        )

    def __todict__(self):
        """
        Return a copy of the private dict mapping name to member.
        """
        return dict(self.__map)


class Registrar(DictProxy):
    """
    Collects plugin classes as they are registered.

    The Registrar does not instantiate plugins... it only implements the
    override logic and stores the plugins in a namespace per allowed base
    class.

    The plugins are instantiated when `API.finalize()` is called.
    """
    def __init__(self, *allowed):
        """
        :param allowed: Base classes from which plugins accepted by this
            Registrar must subclass.
        """
        self.__allowed = dict((base, {}) for base in allowed)
        self.__registered = set()
        super(Registrar, self).__init__(
            dict(self.__base_iter())
        )

    def __base_iter(self):
        for (base, sub_d) in self.__allowed.iteritems():
            assert inspect.isclass(base)
            name = base.__name__
            assert not hasattr(self, name)
            setattr(self, name, MagicDict(sub_d))
            yield (name, base)

    def __findbases(self, klass):
        """
        Iterates through allowed bases that ``klass`` is a subclass of.

        Raises `errors.SubclassError` if ``klass`` is not a subclass of any
        allowed base.

        :param klass: The class to find bases for.
        """
        assert inspect.isclass(klass)
        found = False
        for (base, sub_d) in self.__allowed.iteritems():
            if issubclass(klass, base):
                found = True
                yield (base, sub_d)
        if not found:
            raise errors.SubclassError(klass, self.__allowed.keys())

    def __call__(self, klass, override=False):
        """
        Register the plugin ``klass``.

        :param klass: A subclass of `Plugin` to attempt to register.
        :param override: If true, override an already registered plugin.
        """
        if not inspect.isclass(klass):
            raise TypeError('plugin must be a class: %r'  % klass)

        # Raise DuplicateError if this exact class was already registered:
        if klass in self.__registered:
            raise errors.DuplicateError(klass)

        # Find the base class or raise SubclassError:
        for (base, sub_d) in self.__findbases(klass):
            # Check override:
            if klass.__name__ in sub_d:
                if not override:
                    # Must use override=True to override:
                    raise errors.OverrideError(base, klass)
            else:
                if override:
                    # There was nothing already registered to override:
                    raise errors.MissingOverrideError(base, klass)

            # The plugin is okay, add to sub_d:
            sub_d[klass.__name__] = klass

        # The plugin is okay, add to __registered:
        self.__registered.add(klass)


class API(DictProxy):
    """
    Dynamic API object through which `Plugin` instances are accessed.
    """

    def __init__(self, *allowed):
        self.__d = dict()
        self.__done = set()
        self.register = Registrar(*allowed)
        self.env = Env()
        super(API, self).__init__(self.__d)

    def __doing(self, name):
        if name in self.__done:
            raise StandardError(
                '%s.%s() already called' % (self.__class__.__name__, name)
            )
        self.__done.add(name)

    def __do_if_not_done(self, name):
        if name not in self.__done:
            getattr(self, name)()

    def isdone(self, name):
        return name in self.__done

    def bootstrap(self, **overrides):
        """
        Initialize environment variables needed by built-in plugins.
        """
        self.__doing('bootstrap')
        self.env._bootstrap(**overrides)
        self.env._finalize_core(**dict(constants.DEFAULT_CONFIG))

    def load_plugins(self, dry_run=False):
        """
        Load plugins from all standard locations.

        `API.bootstrap` will automatically be called if it hasn't been
        already.
        """
        self.__doing('load_plugins')
        self.__do_if_not_done('bootstrap')
        if dry_run:
            return
        util.import_plugins_subpackage('ipalib')
        util.import_plugins_subpackage('ipa_server')

    def finalize(self):
        """
        Finalize the registration, instantiate the plugins.

        `API.bootstrap` will automatically be called if it hasn't been
        already.
        """
        self.__doing('finalize')
        self.__do_if_not_done('bootstrap')

        class PluginInstance(object):
            """
            Represents a plugin instance.
            """

            i = 0

            def __init__(self, klass):
                self.created = self.next()
                self.klass = klass
                self.instance = klass()
                self.bases = []

            @classmethod
            def next(cls):
                cls.i += 1
                return cls.i

        class PluginInfo(ReadOnly):
            def __init__(self, p):
                assert isinstance(p, PluginInstance)
                self.created = p.created
                self.name = p.klass.__name__
                self.module = str(p.klass.__module__)
                self.plugin = '%s.%s' % (self.module, self.name)
                self.bases = tuple(b.__name__ for b in p.bases)
                lock(self)

        plugins = {}
        def plugin_iter(base, subclasses):
            for klass in subclasses:
                assert issubclass(klass, base)
                if klass not in plugins:
                    plugins[klass] = PluginInstance(klass)
                p = plugins[klass]
                assert base not in p.bases
                p.bases.append(base)
                if base.__proxy__: